{
    "globals": {
        "Atomics": "readonly",
        "SharedArrayBuffer": "readonly",
        "NodeJS": "readonly"
    },
    "root": true,
    "plugins": [
        "@typescript-eslint/eslint-plugin",
        "eslint-plugin-tsdoc"
    ],
    "extends": [
        "eslint:all",
        "plugin:@typescript-eslint/recommended"
    ],
    "parser": "@typescript-eslint/parser",
    "parserOptions": {
        "project": "./tsconfig.json",
        "tsconfigRootDir": ".",
        "ecmaVersion": 11,
        "sourceType": "module"
    },
    "env": {
        "commonjs": false,
        "es6": true,
        "node": true,
        "browser": false
    },
    "rules": {
        "tsdoc/syntax": "off",
        "array-callback-return": ["error", {"checkForEach": true}],
        "constructor-super": ["error"],
        "for-direction": ["error"],
        "getter-return": ["error"],
        "no-async-promise-executor": ["error"],
        "no-await-in-loop": ["error"],
        "no-class-assign": ["error"],
        "no-compare-neg-zero": ["error"],
        "no-cond-assign": ["error"],
        "no-const-assign": ["error"],
        "no-constant-condition": ["error"],
        "no-constructor-return": ["error"],
        "no-control-regex": ["error"],
        "no-debugger": ["error"],
        "no-dupe-args": ["error"],
        "no-dupe-class-members": ["error"],
        "no-dupe-else-if": ["error"],
        "no-dupe-keys": ["error"],
        "no-duplicate-case": ["error"],
        "no-duplicate-imports": ["error"],
        "no-empty-character-class": ["error"],
        "no-empty-pattern": ["error"],
        "no-ex-assign": ["error"],
        "no-fallthrough": ["error", {"commentPattern": "fallthrough"}],
        "no-func-assign": ["error"],
        "no-import-assign": ["error"],
        "no-inner-declarations": ["error"],
        "no-invalid-regexp": ["error"],
        "no-irregular-whitespace": [
            "error",
            {
                "skipStrings": false,
                "skipComments": false,
                "skipRegExps": false,
                "skipTemplates": false
            }
        ],
        "no-loss-of-precision": ["error"],
        "no-misleading-character-class": ["error"],
        "no-new-symbol": ["error"],
        "no-obj-calls": ["error"],
        "no-promise-executor-return": ["error"],
        "no-prototype-builtins": ["error"],
        "no-self-assign": ["error"],
        "no-self-compare": ["error"],
        "no-setter-return": ["error"],
        "no-sparse-arrays": ["error"],
        "no-template-curly-in-string": ["error"],
        "no-this-before-super": ["error"],
        "no-undef": ["error", {"typeof": true}],
        "no-unexpected-multiline": ["error"],
        "no-unmodified-loop-condition": ["error"],
        "no-unreachable": ["error"],
        "no-unreachable-loop": ["error"],
        "no-unsafe-finally": ["error"],
        "no-unsafe-negation": ["error", {"enforceForOrderingRelations": true}],
        "no-unsafe-optional-chaining": [
            "error",
            {
                "disallowArithmeticOperators": true
            }
        ],
        "no-unused-private-class-members": ["error"],
        "no-unused-vars": [
            "error",
            {
                "vars": "all",
                "args": "all",
                "argsIgnorePattern": "^_",
                "ignoreRestSiblings": false,
                "caughtErrors": "all",
                "caughtErrorsIgnorePattern": "^_"
            }
        ],
        "no-use-before-define": ["error"],
        "no-useless-backreference": ["error"],
        "require-atomic-updates": ["error"],
        "use-isnan": ["error"],
        "valid-typeof": ["error", {"requireStringLiterals": true}],
        // /////////////////////////////////////////////////////////////////////
        "accessor-pairs": [
            "error",
            {
                "setWithoutGet": true,
                "getWithoutSet": false,
                "enforceForClassMembers": true
            }
        ],
        "arrow-body-style": ["error", "always"],
        "block-scoped-var": ["error"],
        "camelcase": [
            "error",
            {
                "properties": "always",
                "ignoreDestructuring": false,
                "ignoreImports": false,
                "ignoreGlobals": false
            }
        ],
        "capitalized-comments": [
            "error",
            "always",
            {
                "ignoreInlineComments": false,
                "ignoreConsecutiveComments": true,
                "ignorePattern": "ntd"
            }
        ],
        "class-methods-use-this": ["error"],
        "complexity": ["error", 30],
        "consistent-return": ["error"],
        "consistent-this": ["error", "self"],
        "curly": ["error", "multi-line", "consistent"],
        "default-case": ["error", {"commentPattern": "^no\\sdefault"}],
        "default-case-last": ["error"],
        "default-param-last": ["error"],
        "dot-notation": [
            "error",
            {
                "allowKeywords": true,
                "allowPattern": "(.*[ \t\\^\\-\\*\\+\\/\\])|(^[0-9])"
            }
        ],
        "eqeqeq": ["error"],
        "func-name-matching": [
            "error",
            "always",
            {
                "considerPropertyDescriptor": true,
                "includeCommonJSModuleExports": true
            }
        ],
        "func-names": ["error", "never"],
        "func-style": ["error", "declaration"],
        "grouped-accessor-pairs": ["error"],
        "guard-for-in": ["error"],
        // "id-denylist": ["error", ...],
        "id-length": [
            "error",
            {
                "min": 2,
                "max": 35,
                "properties": "always",
                "exceptions": [
                    "i",
                    "j",
                    "k",
                    "x",
                    "y",
                    "z"
                ]
            }
        ],
        //"id-match": : ["error", ...regexp],
        "init-declarations": ["error", "always"],
        "max-classes-per-file": ["error", 1],
        "max-depth": ["error", 4],
        "max-lines": [
            "error",
            {
                "max": 1000,
                "skipBlankLines": true,
                "skipComments": true
            }
        ],
        "max-lines-per-function": [
            "error",
            {
                "max": 200,
                "skipBlankLines": true,
                "skipComments": true
            }
        ],
        "max-nested-callbacks": ["error", 3],
        "max-params": ["error", 8],
        "max-statements": ["error", 100],
        "multiline-comment-style": ["error", "separate-lines"],
        "new-cap": [
            "error",
            {
                "newIsCap": true,
                "capIsNew": true,
                "properties": true
            }
        ],
        "no-alert": ["error"],
        "no-array-constructor": ["error"],
        "no-bitwise": ["error"],
        "no-caller": ["error"],
        "no-case-declarations": ["error"],
        "no-confusing-arrow": ["error", {"allowParens": true}],
        "no-console": ["error"],
        "no-continue": "off",
        "no-delete-var": ["error"],
        "no-div-regex": ["error"],
        "no-else-return": ["error", {"allowElseIf": true}],
        "no-empty": ["error"],
        "no-empty-function": ["error"],
        "no-eq-null": ["error"],
        "no-eval": ["error"],
        "no-extend-native": ["error"],
        "no-extra-bind": ["error"],
        "no-extra-boolean-cast": "off",
        "no-extra-label": ["error"],
        "no-extra-semi": ["error"],
        "no-floating-decimal": ["error"],
        "no-global-assign": ["error"],
        "no-implicit-coercion": [
            "error",
            {
                "boolean": true,
                "number": true,
                "string": true,
                "disallowTemplateShorthand": true
            }
        ],
        "no-implicit-globals": ["error", {"lexicalBindings": true}],
        "no-implied-eval": ["error"],
        "no-inline-comments": ["error"],
        "no-invalid-this": ["error"],
        "no-iterator": ["error"],
        "no-label-var": ["error"],
        "no-labels": ["error", {"allowLoop": true}],
        "no-lone-blocks": ["error"],
        "no-lonely-if": ["error"],
        "no-loop-func": ["error"],
        "no-magic-numbers": ["error", { "ignore": [1, -1, 0]}],
        "no-mixed-operators": [
            "error",
            {
                "groups": [
                    ["+", "-"],
                    ["*", "/", "%", "**"],
                    ["&", "|", "^", "~", "<<", ">>", ">>>"],
                     ["==", "!=", "===", "!==", ">", ">=", "<", "<="],
                    ["&&", "||"],
                    ["in", "instanceof"]
                ],
                "allowSamePrecedence": true
            }
        ],
        "no-multi-assign": ["error"],
        "no-multi-str": ["error"],
        "no-negated-condition": "off",
        "no-nested-ternary": ["error"],
        "no-new": ["error"],
        "no-new-func": ["error"],
        "no-new-object": ["error"],
        "no-new-wrappers": ["error"],
        "no-nonoctal-decimal-escape": ["error"],
        "no-octal": ["error"],
        "no-octal-escape": ["error"],
        "no-param-reassign": ["error"],
        "no-plusplus": ["error", {"allowForLoopAfterthoughts": true}],
        "no-proto": ["error"],
        "no-redeclare": ["error"],
        "no-regex-spaces": ["error"],
        // "no-restricted-exports"
        // "no-restricted-globals"
        "no-restricted-imports": "off",
        // "no-restricted-properties"
        // "no-restricted-syntax"
        "no-return-assign": ["error", "always"],
        "no-return-await": ["error"],
        "no-script-url": ["error"],
        "no-sequences": ["error", {"allowInParentheses": false}],
        "no-shadow": ["error"],
        "no-shadow-restricted-names": ["error"],
        "no-ternary": "off",
        "no-throw-literal": ["error"],
        "no-undef-init": "off",
        "no-undefined": ["error"],
        "no-underscore-dangle": "off",
        "no-unneeded-ternary": ["error"],
        "no-unused-expressions": [
            "error",
            {
                "allowShortCircuit": false,
                "allowTernary": false,
                "allowTaggedTemplates": false,
                "enforceForJSX": false
            }
        ],
        "no-unused-labels": ["error"],
        "no-useless-call": ["error"],
        "no-useless-catch": ["error"],
        "no-useless-computed-key": ["error", {"enforceForClassMembers": true}],
        "no-useless-concat": ["error"],
        "no-useless-constructor": ["error"],
        "no-useless-escape": ["error"],
        "no-useless-rename": ["error"],
        "no-useless-return": ["error"],
        "no-var": ["error"],
        "no-void": ["error"],
        "no-warning-comments": [
            "off",
            {
                "terms": ["@todo", "@fixme", "@TODO", "@FIXME", "@HERE"],
                "location": "start"
            }
        ],
        "no-with": ["error"],
        "object-shorthand": [
            "error",
            "methods",
            {
                "avoidQuotes": false,
                "ignoreConstructors": false,
                "avoidExplicitReturnArrows": false
            }
        ],
        "one-var": ["error", "never"],
        "one-var-declaration-per-line": ["error", "always"],
        "operator-assignment": ["error", "always"],
        "prefer-arrow-callback": [
            "error",
            {
                "allowNamedFunctions": true,
                "allowUnboundThis": false
            }
        ],
        "prefer-const": ["error"],
        "prefer-destructuring": "off",
        "prefer-exponentiation-operator": ["error"],
        "prefer-named-capture-group": ["error"],
        "prefer-numeric-literals": ["error"],
        "prefer-object-has-own": ["error"],
        "prefer-object-spread": ["error"],
        "prefer-promise-reject-errors": ["error", {"allowEmptyReject": false}],
        "prefer-regex-literals": ["error", {"disallowRedundantWrapping": true}],
        "prefer-rest-params": ["error"],
        "prefer-spread": ["error"],
        "prefer-template": ["error"],
        "quote-props": ["error", "always"],
        "radix": ["error"],
        "require-await": "off",
        "require-unicode-regexp": ["error"],
        "require-yield": ["error"],
        "sort-imports": [
            "error",
            {
                "ignoreCase": true,
                "ignoreDeclarationSort": false,
                "ignoreMemberSort": false,
                "memberSyntaxSortOrder": [
                    "none",
                    "all",
                    "multiple",
                    "single"
                ]
            }
        ],
        "sort-keys": [
            "error",
            "asc",
            {
                "caseSensitive": false,
                "natural": false,
                "minKeys": 2
            }
        ],
        "spaced-comment": [
            "error",
            "always",
            {
                "markers": [
                    "/"
                ]
            }
        ],
        // "strict"
        "symbol-description": ["error"],
        "vars-on-top": ["error"],
        "yoda": ["error", "never"],
        // /////////////////////////////////////////////////////////////////////
        "array-bracket-newline": ["error", "consistent"],
        "array-bracket-spacing": ["error", "never"],
        "array-element-newline": ["error", "consistent"],
        "arrow-parens": ["error", "always"],
        "arrow-spacing": ["error", {"before": true, "after": true}],
        "block-spacing": ["error", "never"],
        "brace-style": ["error", "allman", {"allowSingleLine": true}],
        "comma-dangle": ["error", "never"],
        "comma-spacing": ["error", {"before": false, "after": true}],
        "comma-style": ["error", "last"],
        "computed-property-spacing": ["error", "never"],
        "dot-location": ["error", "property"],
        "eol-last": ["error", "always"],
        "func-call-spacing": ["error", "never"],
        "function-call-argument-newline": ["error", "consistent"],
        "function-paren-newline": ["error", "consistent"],
        "generator-star-spacing": ["error", "after"],
        "implicit-arrow-linebreak": "off",
        "indent": [
            "error",
            4,
            {
                "ArrayExpression": 1,
                "CallExpression": {
                    "arguments": 1
                },
                "flatTernaryExpressions": true,
                "FunctionDeclaration": {
                    "parameters": 1,
                    "body": 1
                },
                "FunctionExpression": {
                    "parameters": 1,
                    "body": 1
                },
                "ignoreComments": false,
                "ImportDeclaration": 1,
                "MemberExpression": 1,
                "ObjectExpression": 1,
                "offsetTernaryExpressions": false,
                "outerIIFEBody": 1,
                "StaticBlock": {
                    "body": 1
                },
                "SwitchCase": 1,
                "VariableDeclarator": 1
            }
        ],
        "jsx-quotes": ["error", "prefer-double"],
        "key-spacing": [
            "error",
            {
                "beforeColon": false,
                "afterColon": true,
                "mode": "strict"
            }
        ],
        "keyword-spacing": ["error", {"before": true, "after": true}],
        "line-comment-position": ["error", {"position": "above"}],
        "linebreak-style": ["error", "unix"],
        "lines-around-comment": [
            "error",
            {
                "beforeBlockComment": false, // (default) requires an empty line before block comments
                "afterBlockComment": false, // requires an empty line after block comments
                "beforeLineComment": false, // requires an empty line before line comments
                "afterLineComment": false, // requires an empty line after line comments
                "allowBlockStart": true, // allows comments to appear at the start of block statements
                "allowBlockEnd": true, // allows comments to appear at the end of block statements
                "allowObjectStart": true, // allows comments to appear at the start of object literals
                "allowObjectEnd": true, // allows comments to appear at the end of object literals
                "allowArrayStart": true, // allows comments to appear at the start of array literals
                "allowArrayEnd": true, // allows comments to appear at the end of array literals
                "allowClassStart": true, // allows comments to appear at the start of classes
                "allowClassEnd": true
            }
        ],
        "lines-between-class-members": [
            "error",
            "always",
            {
                "exceptAfterSingleLine": true
            }
        ],
        "max-len": [
            "error",
            {
                "code": 80,
                "tabWidth": 4,
                "ignoreComments": false,
                "ignoreTrailingComments": false,
                "ignoreUrls": false,
                "ignoreStrings": false,
                "ignoreTemplateLiterals": false,
                "ignoreRegExpLiterals": false
            }
        ],
        "max-statements-per-line": ["error", {"max": 2}],
        "multiline-ternary": ["error", "always-multiline"],
        "new-parens": ["error", "always"],
        "newline-per-chained-call": ["error"],
        "no-extra-parens": ["error", "all", {"nestedBinaryExpressions": false}],
        "no-mixed-spaces-and-tabs": ["error"],
        "no-multi-spaces": ["error"],
        "no-multiple-empty-lines": ["error", {"max": 2}],
        "no-tabs": ["error"],
        "no-trailing-spaces": ["error"],
        "no-whitespace-before-property": ["error"],
        "nonblock-statement-body-position": [
            "error",
            "below",
            {
                "overrides": {
                    "if": "any",
                    "else": "any"
                }
            }
        ],
        "object-curly-newline": [
            "error",
            {
                "ObjectExpression": {"multiline": true, "minProperties": 3, "consistent": true},
                "ObjectPattern": {"multiline": true, "minProperties": 3, "consistent": true},
                "ImportDeclaration": {"multiline": true, "minProperties": 2, "consistent": true},
                "ExportDeclaration":  {"multiline": true, "minProperties": 3, "consistent": true}
            }
        ],
        "object-curly-spacing": ["error", "never"],
        "object-property-newline": ["error", {"allowAllPropertiesOnSameLine": true}],
        "operator-linebreak": ["error", "before", {"overrides": {"=": "after"}}],
        "padded-blocks": ["error", "never"],
        // "padding-line-between-statements"
        "quotes": ["error", "double"],
        "rest-spread-spacing": ["error", "never"],
        "semi": ["error", "always"],
        "semi-spacing": ["error", {"before": false, "after": true}],
        "semi-style": ["error", "last"],
        "space-before-blocks": ["error", "always"],
        "space-before-function-paren": ["error", "never"],
        "space-in-parens": ["error", "never"],
        "space-infix-ops": ["error"],
        "space-unary-ops": ["error", {"words": true, "nonwords": false}],
        "switch-colon-spacing": ["error", {"after": true, "before": false}],
        "template-curly-spacing": ["error", "never"],
        "template-tag-spacing": ["error", "never"],
        "unicode-bom": ["error", "never"],
        "wrap-iife": ["error", "inside", {"functionPrototypeMethods": true}],
        "wrap-regex": ["error"],
        "yield-star-spacing": ["error", "after"]
    },
    "overrides": [
        {
            "files": [
                "*.ts",
                "*.tsx"
            ],
            "rules": {
                "tsdoc/syntax": "error",
                "brace-style": "off",
                "comma-dangle": "off",
                "comma-spacing": "off",
                "default-case": "off",
                "dot-notation": "off",
                "default-param-last": "off",
                "func-call-spacing": "off",
                "indent": "off",
                "init-declarations": "off",
                "keyword-spacing": "off",
                "lines-between-class-members": "off",
                "no-array-constructor": "off",
                "no-dupe-class-members": "off",
                "no-duplicate-imports": "off",
                "no-empty-function": "off",
                "no-extra-parens": "off",
                "no-extra-semi": "off",
                "no-implied-eval": "off",
                "no-invalid-this": "off",
                "no-loop-func": "off",
                "no-loss-of-precision": "off",
                "no-magic-numbers": "off",
                "no-redeclare": "off",
                "no-restricted-imports": "off",
                "no-shadow": "off",
                "no-throw-literal": "off",
                "no-unused-expressions": "off",
                "no-unused-vars": "off",
                "no-use-before-define": "off",
                "no-useless-constructor": "off",
                "object-curly-spacing": "off",
                "padding-line-between-statements": "off",
                "quotes": "off",
                "require-await": "off",
                "no-return-await": "off",
                "semi": "off",
                "space-before-function-paren": "off",
                "space-infix-ops": "off",
                // /////////////////////////////////////////////////////////////
                "@typescript-eslint/adjacent-overload-signatures": ["error"],
                "@typescript-eslint/array-type": [
                    "error",
                    {
                        "default": "generic"
                    }
                ],
                "@typescript-eslint/await-thenable": ["error"],
                "@typescript-eslint/ban-ts-comment": ["error"],
                "@typescript-eslint/ban-tslint-comment": ["error"],
                "@typescript-eslint/ban-types": ["error"],
                "@typescript-eslint/class-literal-property-style": [
                    "error",
                    "getters"
                ],
                "@typescript-eslint/consistent-indexed-object-style": [
                    "error",
                    "index-signature"
                ],
                "@typescript-eslint/consistent-type-assertions": [
                    "error",
                    {
                        "assertionStyle": "as",
                        "objectLiteralTypeAssertions": "allow-as-parameter"
                    }
                ],
                "@typescript-eslint/consistent-type-definitions": "off",
                "@typescript-eslint/consistent-type-exports": [
                    "error",
                    {
                        "fixMixedExportsWithInlineTypeSpecifier": true
                    }
                ],
                "@typescript-eslint/consistent-type-imports": [
                    "error",
                    {
                        "prefer": "type-imports",
                        "disallowTypeAnnotations": true
                    }
                ],
                "@typescript-eslint/explicit-function-return-type": [
                    "error",
                    {
                        "allowExpressions": false,
                        "allowTypedFunctionExpressions": true,
                        "allowHigherOrderFunctions": false,
                        "allowDirectConstAssertionInArrowFunctions": false,
                        "allowConciseArrowFunctionExpressionsStartingWithVoid": false
                    }
                ],
                "@typescript-eslint/explicit-member-accessibility": [
                    "error",
                    {
                        "accessibility": "explicit"
                    }
                ],
                "@typescript-eslint/explicit-module-boundary-types": [
                    "error",
                    {
                        "allowArgumentsExplicitlyTypedAsAny": false,
                        "allowDirectConstAssertionInArrowFunctions": false,
                        "allowHigherOrderFunctions": false,
                        "allowTypedFunctionExpressions": false
                    }
                ],
                "@typescript-eslint/member-delimiter-style": [
                    "error",
                    {
                        "multiline": {
                        "delimiter": "semi",
                        "requireLast": true
                        },
                        "singleline": {
                        "delimiter": "semi",
                        "requireLast": false
                        },
                        "multilineDetection": "brackets"
                    }
                ],
                "@typescript-eslint/member-ordering": [
                    "error",
                    {
                        "default": {
                            "order": "alphabetically-case-insensitive",
                            "memberTypes": [
                                "public-static-field",
                                "protected-static-field",
                                "private-static-field",
                                "public-static-get",
                                "public-static-set",
                                "protected-static-get",
                                "protected-static-set",
                                "private-static-get",
                                "private-static-set",
                                "public-instance-field",
                                "protected-instance-field",
                                "private-instance-field",
                                "public-static-method",
                                "public-instance-get",
                                "public-instance-set",
                                "public-instance-method",
                                "public-abstract-get",
                                "public-abstract-set",
                                "public-abstract-method",
                                "protected-static-method",
                                "protected-instance-get",
                                "protected-instance-set",
                                "protected-instance-method",
                                "protected-abstract-get",
                                "protected-abstract-set",
                                "protected-abstract-method",
                                "private-static-method",
                                "private-instance-get",
                                "private-instance-set",
                                "private-instance-method",
                                "abstract-get",
                                "abstract-set",
                                "abstract-method"
                            ]
                        }
                    }
                ],
                "@typescript-eslint/method-signature-style": [
                    "error",
                    "method"
                ],
                "@typescript-eslint/naming-convention": [
                    "error",
                    {
                        "selector": "default",
                        "format": ["camelCase", "PascalCase", "UPPER_CASE"],
                        "leadingUnderscore": "allow",
                        "trailingUnderscore": "forbid"
                    },
                    // consts
                    {
                        "selector": "variable",
                        "format": ["UPPER_CASE"],
                        "modifiers": ["const", "global", "exported"],
                        "leadingUnderscore": "forbid",
                        "trailingUnderscore": "forbid"
                    },
                    {
                        "selector": "variable",
                        "format": ["UPPER_CASE"],
                        "modifiers": ["const", "global"],
                        "leadingUnderscore": "require",
                        "trailingUnderscore": "forbid"
                    },
                    {
                        "selector": "variable",
                        "format": ["camelCase", "UPPER_CASE"],
                        "modifiers": ["const"],
                        "leadingUnderscore": "forbid",
                        "trailingUnderscore": "forbid"
                    },
                    // vars
                    {
                        "selector": "variable",
                        "format": ["camelCase"],
                        "modifiers": ["global", "exported"],
                        "leadingUnderscore": "forbid",
                        "trailingUnderscore": "forbid"
                    },
                    {
                        "selector": "variable",
                        "format": ["camelCase"],
                        "modifiers": ["global"],
                        "leadingUnderscore": "require",
                        "trailingUnderscore": "forbid"
                    },
                    {
                        "selector": "variable",
                        "format": ["camelCase"],
                        "leadingUnderscore": "forbid",
                        "trailingUnderscore": "forbid"
                    },
                    // funcs
                    {
                        "selector": "function",
                        "format": ["camelCase"],
                        "modifiers": ["global", "exported"],
                        "leadingUnderscore": "forbid",
                        "trailingUnderscore": "forbid"
                    },
                    {
                        "selector": "function",
                        "format": ["camelCase"],
                        "modifiers": ["global"],
                        "leadingUnderscore": "require",
                        "trailingUnderscore": "forbid"
                    },
                    {
                        "selector": "function",
                        "format": ["camelCase"],
                        "leadingUnderscore": "forbid",
                        "trailingUnderscore": "forbid"
                    },
                    // params
                    {
                        "selector": "parameter",
                        "format": ["camelCase"],
                        "modifiers": ["unused"],
                        "leadingUnderscore": "require",
                        "trailingUnderscore": "forbid"
                    },
                    {
                        "selector": "parameter",
                        "format": ["camelCase"],
                        "leadingUnderscore": "forbid",
                        "trailingUnderscore": "forbid"
                    },
                    // class static readonly props
                    {
                        "selector": "classProperty",
                        "format": ["UPPER_CASE"],
                        "modifiers": ["readonly", "static", "public"],
                        "leadingUnderscore": "forbid",
                        "trailingUnderscore": "forbid"
                    },
                    {
                        "selector": "classProperty",
                        "format": ["UPPER_CASE"],
                        "modifiers": ["readonly", "static", "protected"],
                        "leadingUnderscore": "require",
                        "trailingUnderscore": "forbid"
                    },
                    {
                        "selector": "classProperty",
                        "format": ["UPPER_CASE"],
                        "modifiers": ["readonly", "static", "private"],
                        "leadingUnderscore": "require",
                        "trailingUnderscore": "forbid"
                    },
                    // class static props
                    {
                        "selector": "classProperty",
                        "format": ["camelCase"],
                        "modifiers": ["static", "public"],
                        "leadingUnderscore": "forbid",
                        "trailingUnderscore": "forbid"
                    },
                    {
                        "selector": "classProperty",
                        "format": ["camelCase"],
                        "modifiers": ["static", "protected"],
                        "leadingUnderscore": "require",
                        "trailingUnderscore": "forbid"
                    },
                    {
                        "selector": "classProperty",
                        "format": ["camelCase"],
                        "modifiers": ["static", "private"],
                        "leadingUnderscore": "require",
                        "trailingUnderscore": "forbid"
                    },
                    // class props - vars or readonly
                    {
                        "selector": "classProperty",
                        "format": ["camelCase"],
                        "modifiers": ["public"],
                        "leadingUnderscore": "forbid",
                        "trailingUnderscore": "forbid"
                    },
                    {
                        "selector": "classProperty",
                        "format": ["camelCase"],
                        "modifiers": ["protected"],
                        "leadingUnderscore": "require",
                        "trailingUnderscore": "forbid"
                    },
                    {
                        "selector": "classProperty",
                        "format": ["camelCase"],
                        "modifiers": ["private"],
                        "leadingUnderscore": "require",
                        "trailingUnderscore": "forbid"
                    },
                    // method =
                    // objectLiteralMethod
                    // + typeMethod
                    // + class methods
                    {
                        "selector": "method",
                        "format": ["camelCase"],
                        "modifiers": ["public"],
                        "leadingUnderscore": "forbid",
                        "trailingUnderscore": "forbid"
                    },
                    {
                        "selector": "method",
                        "format": ["camelCase"],
                        "modifiers": ["protected", "abstract"],
                        "leadingUnderscore": "forbid",
                        "trailingUnderscore": "forbid"
                    },
                    {
                        "selector": "method",
                        "format": ["camelCase"],
                        "modifiers": ["protected"],
                        "leadingUnderscore": "allow",
                        "trailingUnderscore": "forbid"
                    },
                    {
                        "selector": "method",
                        "format": ["camelCase"],
                        "modifiers": ["private"],
                        "leadingUnderscore": "require",
                        "trailingUnderscore": "forbid"
                    },
                    // accessor
                    {
                        "selector": "accessor",
                        "format": ["camelCase", "UPPER_CASE"],
                        "modifiers": ["public"],
                        "leadingUnderscore": "forbid",
                        "trailingUnderscore": "forbid"
                    },
                    {
                        "selector": "accessor",
                        "format": ["camelCase", "UPPER_CASE"],
                        "modifiers": ["protected"],
                        "leadingUnderscore": "require",
                        "trailingUnderscore": "forbid"
                    },
                    {
                        "selector": "accessor",
                        "format": ["camelCase", "UPPER_CASE"],
                        "modifiers": ["private"],
                        "leadingUnderscore": "require",
                        "trailingUnderscore": "forbid"
                    },
                    // enumMember
                    {
                        "selector": "enumMember",
                        "format": ["UPPER_CASE"],
                        "leadingUnderscore": "forbid",
                        "trailingUnderscore": "forbid"
                    },
                    // enum, class, typeAlias
                    {
                        "selector": ["enum", "class", "typeAlias"],
                        "format": ["PascalCase"],
                        "modifiers": ["exported"],
                        "leadingUnderscore": "forbid",
                        "trailingUnderscore": "forbid"
                    },
                    {
                        "selector": ["enum", "class", "typeAlias"],
                        "format": ["PascalCase"],
                        "leadingUnderscore": "require",
                        "trailingUnderscore": "forbid"
                    },
                    // interface
                    {
                        "selector": "interface",
                        "format": ["PascalCase"],
                        "custom": {
                            "regex": "^[IT][A-Z].*",
                            "match": true
                        },
                        "modifiers": ["exported"],
                        "leadingUnderscore": "forbid",
                        "trailingUnderscore": "forbid"
                    },
                    {
                        "selector": "interface",
                        "format": ["PascalCase"],
                        "custom": {
                            "regex": "^[IT][A-Z].*",
                            "match": true
                        },
                        "leadingUnderscore": "require",
                        "trailingUnderscore": "forbid"
                    },
                    // typeParameter
                    {
                        "selector": "typeParameter",
                        "format": ["UPPER_CASE", "PascalCase"],
                        "leadingUnderscore": "forbid",
                        "trailingUnderscore": "forbid"
                    }
                    // objectLiteralProperty
                    // parameterProperty
                ],
                "@typescript-eslint/no-base-to-string": ["error"],
                "@typescript-eslint/no-confusing-non-null-assertion": ["error"],
                "@typescript-eslint/no-confusing-void-expression": ["error"],
                "@typescript-eslint/no-dynamic-delete": ["error"],
                "@typescript-eslint/no-empty-interface": [
                    "error",
                    {
                        "allowSingleExtends": false
                    }
                ],
                "@typescript-eslint/no-explicit-any": [
                    "error",
                    {
                        "fixToUnknown": true,
                        "ignoreRestArgs": false
                    }
                ],
                "@typescript-eslint/no-extra-non-null-assertion": ["error"],
                "@typescript-eslint/no-extraneous-class": [
                    "error",
                    {
                        "allowConstructorOnly": true,
                        "allowEmpty": true,
                        "allowStaticOnly": false,
                        "allowWithDecorator": false
                    }
                ],
                "@typescript-eslint/no-floating-promises": [
                    "error",
                    {
                        "ignoreVoid": false,
                        "ignoreIIFE": false
                    }
                ],
                "@typescript-eslint/no-for-in-array": ["error"],
                "@typescript-eslint/no-inferrable-types": ["error"],
                "@typescript-eslint/no-invalid-void-type": ["error"],
                "@typescript-eslint/no-meaningless-void-operator": ["error"],
                "@typescript-eslint/no-misused-new": ["error"],
                "@typescript-eslint/no-misused-promises": ["error"],
                "@typescript-eslint/no-namespace": ["error"],
                "@typescript-eslint/no-non-null-asserted-nullish-coalescing":
                [
                    "error"
                ],
                "@typescript-eslint/no-non-null-asserted-optional-chain": [
                    "error"
                ],
                "@typescript-eslint/no-non-null-assertion": "off",
                "@typescript-eslint/no-parameter-properties": ["error"],
                "@typescript-eslint/no-require-imports": ["error"],
                "@typescript-eslint/no-this-alias": [
                    "error",
                    {
                        "allowDestructuring": false,
                        "allowedNames": ["self"]
                    }
                ],
                "@typescript-eslint/no-type-alias": "off",
                "@typescript-eslint/no-unnecessary-boolean-literal-compare":
                [
                    "error"
                ],
                "@typescript-eslint/no-unnecessary-condition": ["error"],
                "@typescript-eslint/no-unnecessary-qualifier": ["error"],
                "@typescript-eslint/no-unnecessary-type-arguments": ["error"],
                "@typescript-eslint/no-unnecessary-type-assertion": ["error"],
                "@typescript-eslint/no-unnecessary-type-constraint": ["error"],
                "@typescript-eslint/no-unsafe-argument": ["error"],
                "@typescript-eslint/no-unsafe-assignment": ["error"],
                "@typescript-eslint/no-unsafe-call": ["error"],
                "@typescript-eslint/no-unsafe-member-access": ["error"],
                "@typescript-eslint/no-unsafe-return": ["error"],
                "@typescript-eslint/no-var-requires": ["error"],
                "@typescript-eslint/non-nullable-type-assertion-style": ["error"],
                "@typescript-eslint/prefer-as-const": ["error"],
                "@typescript-eslint/prefer-enum-initializers": "off",
                "@typescript-eslint/prefer-for-of": ["error"],
                "@typescript-eslint/prefer-function-type": ["error"],
                "@typescript-eslint/prefer-includes": ["error"],
                "@typescript-eslint/prefer-literal-enum-member": ["error"],
                "@typescript-eslint/prefer-namespace-keyword": ["error"],
                "@typescript-eslint/prefer-nullish-coalescing": ["error"],
                "@typescript-eslint/prefer-optional-chain": ["error"],
                "@typescript-eslint/prefer-readonly": ["error"],
                "@typescript-eslint/prefer-readonly-parameter-types": "off",
                "@typescript-eslint/prefer-reduce-type-parameter": ["error"],
                "@typescript-eslint/prefer-regexp-exec": "off",
                "@typescript-eslint/prefer-return-this-type": ["error"],
                "@typescript-eslint/prefer-string-starts-ends-with": ["error"],
                "@typescript-eslint/prefer-ts-expect-error": ["error"],
                "@typescript-eslint/promise-function-async": ["error"],
                "@typescript-eslint/require-array-sort-compare": [
                    "error",
                    {
                        "ignoreStringArrays": true
                    }
                ],
                "@typescript-eslint/restrict-plus-operands": [
                    "error",
                    {
                        "checkCompoundAssignments": true,
                        "allowAny": false
                    }
                ],
                "@typescript-eslint/restrict-template-expressions": [
                    "error",
                    {
                        "allowNumber": false,
                        "allowBoolean": false,
                        "allowAny": false,
                        "allowNullish": false,
                        "allowRegExp": false
                    }
                ],
                "@typescript-eslint/sort-type-union-intersection-members": [
                    "error"
                ],
                "@typescript-eslint/strict-boolean-expressions": [
                    "error",
                    {
                        "allowString": false,
                        "allowNumber": false,
                        "allowNullableObject": false,
                        "allowNullableBoolean": false,
                        "allowNullableString": false,
                        "allowNullableNumber": false,
                        "allowAny": false
                    }
                ],
                "@typescript-eslint/switch-exhaustiveness-check": ["error"],
                "@typescript-eslint/triple-slash-reference": ["error"],
                "@typescript-eslint/type-annotation-spacing": [
                    "error",
                    {
                        "before": false,
                        "after": false,
                        "overrides": {
                            "colon": {
                                "before": false,
                                "after": true
                            },
                            "arrow": {
                                "before": true,
                                "after": true
                            }
                        }
                    }
                ],
                "@typescript-eslint/typedef": "off",
                "@typescript-eslint/unbound-method": [
                    "error",
                    {
                      "ignoreStatic": true
                    }
                ],
                "@typescript-eslint/unified-signatures": ["error"],
                // /////////////////////////////////////////////////////////////
                "@typescript-eslint/brace-style": ["error", "allman", {"allowSingleLine": true}],
                "@typescript-eslint/comma-dangle": ["error", "never"],
                "@typescript-eslint/comma-spacing": ["error", {"before": false, "after": true}],
                "@typescript-eslint/default-param-last": ["error"],
                "@typescript-eslint/dot-notation": [
                    "error",
                    {
                        "allowKeywords": true,
                        "allowPattern": "(.*[ \t\\^\\-\\*\\+\\/\\])|(^[0-9])",
                        "allowPrivateClassPropertyAccess": false,
                        "allowProtectedClassPropertyAccess": false,
                        "allowIndexSignaturePropertyAccess": false
                    }
                ],
                "@typescript-eslint/func-call-spacing": ["error", "never"],
                "@typescript-eslint/indent": [
                    "error",
                    4,
                    {
                        "ArrayExpression": 1,
                        "CallExpression": {
                            "arguments": 1
                        },
                        "flatTernaryExpressions": true,
                        "FunctionDeclaration": {
                            "parameters": 1,
                            "body": 1
                        },
                        "FunctionExpression": {
                            "parameters": 1,
                            "body": 1
                        },
                        "ignoreComments": false,
                        "ImportDeclaration": 1,
                        "MemberExpression": 1,
                        "ObjectExpression": 1,
                        "offsetTernaryExpressions": false,
                        "outerIIFEBody": 1,
                        "StaticBlock": {
                            "body": 1
                        },
                        "SwitchCase": 1,
                        "VariableDeclarator": 1
                    }
                ],
                "@typescript-eslint/init-declarations": ["error", "always"],
                "@typescript-eslint/keyword-spacing": ["error", {"before": true, "after": true}],
                "@typescript-eslint/lines-between-class-members": [
                    "error",
                    "always",
                    {
                        "exceptAfterSingleLine": true,
                        "exceptAfterOverload": false
                    }
                ],
                "@typescript-eslint/no-array-constructor": ["error"],
                "@typescript-eslint/no-dupe-class-members": ["error"],
                "@typescript-eslint/no-duplicate-imports": ["error"],
                "@typescript-eslint/no-empty-function": ["error"],
                "@typescript-eslint/no-extra-parens": ["error", "all", {"nestedBinaryExpressions": false}],
                "@typescript-eslint/no-extra-semi": ["error"],
                "@typescript-eslint/no-implied-eval": ["error"],
                "@typescript-eslint/no-invalid-this": ["error"],
                "@typescript-eslint/no-loop-func": ["error"],
                "@typescript-eslint/no-loss-of-precision": ["error"],
                "@typescript-eslint/no-magic-numbers": ["error", { "ignore": [1, -1, 0]}],
                "@typescript-eslint/no-redeclare": ["error"],
                "@typescript-eslint/no-restricted-imports": "off",
                "@typescript-eslint/no-shadow": ["error"],
                "@typescript-eslint/no-throw-literal": ["error"],
                "@typescript-eslint/no-unused-expressions": [
                    "error",
                    {
                        "allowShortCircuit": false,
                        "allowTernary": false,
                        "allowTaggedTemplates": false,
                        "enforceForJSX": false
                    }
                ],
                "@typescript-eslint/no-unused-vars": [
                    "error",
                    {
                        "vars": "all",
                        "args": "all",
                        "argsIgnorePattern": "^_",
                        "ignoreRestSiblings": false,
                        "caughtErrors": "all",
                        "caughtErrorsIgnorePattern": "^_"
                    }
                ],
                "@typescript-eslint/no-use-before-define": ["error"],
                "@typescript-eslint/no-useless-constructor": ["error"],
                "@typescript-eslint/object-curly-spacing": ["error", "never"],
                // "@typescript-eslint/padding-line-between-statements"
                "@typescript-eslint/quotes": ["error", "double"],
                "@typescript-eslint/require-await": "off",
                "@typescript-eslint/return-await": ["error"],
                "@typescript-eslint/semi": ["error", "always"],
                "@typescript-eslint/space-before-function-paren": ["error", "never"],
                "@typescript-eslint/space-infix-ops": ["error"]
            }
        }
    ]
}
